<?php
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');

class plgJshoppingCheckoutJshopping_captcha extends JPlugin{

    function __construct(&$subject, $config){
        parent::__construct($subject, $config);
    }
	
	function onBeforeDisplayRegisterView(&$view) {
		$plugin = JComponentHelper::getParams('com_users')->get('captcha', JFactory::getConfig()->get('captcha'));
		if ($plugin === 0 || $plugin === '0' || $plugin === '' || $plugin === null) return;
		
		$language = JFactory::getLanguage();
		$language->load('com_users');
		
		$captcha = new JCaptcha($plugin, array());
		if ($plugin == 'recaptcha_invisible') {
			$view->_tmpl_register_html_5 .= $captcha->display('jshopping_captcha', 'jshopping_captcha', 'jshopping_captcha');
		} else {
			$view->_tmpl_register_html_5 .= '<div class = "jshop_register"><table><tr><td class="name">'.JText::_('COM_USERS_CAPTCHA_LABEL').' <span>*</span></td><td>'.$captcha->display('jshopping_captcha', 'jshopping_captcha', 'jshopping_captcha').'</td></tr></table></div>';
		}
	}
	
	function onBeforeRegister(&$post, &$default_usergroup) {
		$plugin = JComponentHelper::getParams('com_users')->get('captcha', JFactory::getConfig()->get('captcha'));
		if ($plugin === 0 || $plugin === '0' || $plugin === '' || $plugin === null) return;
		if (JRequest::getVar('controller') != 'user') return;
		
		$jshopConfig = JSFactory::getConfig();
		$app = JFactory::getApplication();
		$language = JFactory::getLanguage();		
        $language->load('plg_captcha_'.$plugin, JPATH_ROOT.'/administrator');
		
		$captcha = new JCaptcha($plugin, array());
		try{
			if (!$captcha->checkAnswer(null)){
				$error = $captcha->getError();
				print_r($error); die();
				if ($error instanceof Exception) {
					JError::raiseWarning('', $error);
				} else {
					JError::raiseWarning('', new JException($error));
				}
				$this->savePostData($post);
				$app->redirect(SEFLink("index.php?option=com_jshopping&controller=user&task=register&lrd=1",1,1, $jshopConfig->use_ssl));
			}
		}catch(\RuntimeException $e){
			JError::raiseWarning('', $e->getMessage());
			$this->savePostData($post);
			$app->redirect(SEFLink("index.php?option=com_jshopping&controller=user&task=register&lrd=1",1,1, $jshopConfig->use_ssl));
		}		
		
		
	}
	
	private function savePostData($data){
		$session = JFactory::getSession();            
        $session->set('registrationdata', $data);
	}

	function onBeforeDisplayCheckoutStep2View(&$view) {
		$user = JSFactory::getUser();
		
		if($this->params->get('add_to_step2') == 1) {
			if($user->user_id == -1) {
				$plugin = JComponentHelper::getParams('com_users')->get('captcha', JFactory::getConfig()->get('captcha'));
				if ($plugin === 0 || $plugin === '0' || $plugin === '' || $plugin === null) return;
				
				$language = JFactory::getLanguage();
				$language->load('com_users');
				
				$captcha = new JCaptcha($plugin, array());
				if ($plugin == 'recaptcha_invisible') {
					$view->_tmp_ext_html_address_end .= $captcha->display('jshopping_captcha', 'jshopping_captcha', 'jshopping_captcha');
				} else {
					$view->_tmp_ext_html_address_end .= '<div class = "jshop_register"><table><tr><td class="name">'.JText::_('COM_USERS_CAPTCHA_LABEL').' <span>*</span></td><td>'.$captcha->display('jshopping_captcha', 'jshopping_captcha', 'jshopping_captcha').'</td></tr></table></div>';
				}
			}
		}
	}

	function onLoadCheckoutStep2save(&$post) {
		$user = JSFactory::getUser();
		
		if($this->params->get('add_to_step2') == 1) {
			if($user->user_id == -1) {

				$plugin = JComponentHelper::getParams('com_users')->get('captcha', JFactory::getConfig()->get('captcha'));
				if ($plugin === 0 || $plugin === '0' || $plugin === '' || $plugin === null) return;
				
				$jshopConfig = JSFactory::getConfig();
				$app = JFactory::getApplication();
				$language = JFactory::getLanguage();		
		        $language->load('plg_captcha_'.$plugin, JPATH_ROOT.'/administrator');
				
				$captcha = new JCaptcha($plugin, array());
				try{
					if (!$captcha->checkAnswer(null)){
						$error = $captcha->getError();
						if ($error instanceof Exception) {
							JError::raiseWarning('', $error);
						} else {
							JError::raiseWarning('', new JException($error));
						}
						$this->savePostData($post);
						$app->redirect(SEFLink("index.php?option=com_jshopping&controller=checkout&task=step2",1,1, $jshopConfig->use_ssl));
					}
				}catch(\RuntimeException $e){
					JError::raiseWarning('', $e->getMessage());
					$this->savePostData($post);                    
					$app->redirect(SEFLink("index.php?option=com_jshopping&controller=checkout&task=step2",1,1, $jshopConfig->use_ssl));
				}
			}
		}
	}
	
}